import * as React from 'react';
interface Option {
    key: string;
    label: string;
}
interface IState<T> {
    showDropdown: boolean;
    selected: (Option | T | string)[];
    isMultiSelectable: boolean;
}
interface IProps<T> {
    name: string;
    options: (Option | T | string)[];
    selected?: (Option | T | string)[];
    isMultiSelectable?: boolean;
    placeholder?: string;
    title?: string;
    placeholderSelect?: string;
    placeholderDeselect?: string;
    buttonClass?: string;
    onChange?: (value: (Option | T | string)[]) => void;
    getOptionKey?: (value: Option | T | string) => string;
    getOptionLabel?: (value: Option | T | string) => string;
}
declare class DropdownMultiselectComponent<T> extends React.Component<IProps<T>, IState<T>> {
    private node;
    constructor(props: IProps<T>);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private onClick;
    private handleSelectAll;
    private handleDeselectAll;
    private handleClickOutside;
}
export declare const DropdownMultiselect: typeof DropdownMultiselectComponent;
export {};
