"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropdownMultiselect = void 0;
const React = require("react");
const DropdownMultiselectToggleBtn_1 = require("./DropdownMultiselectToggleBtn");
const DropdownMultiselectSelection_1 = require("./DropdownMultiselectSelection");
const DropdownMultiselectOption_1 = require("./DropdownMultiselectOption");
class DropdownMultiselectComponent extends React.Component {
    constructor(props) {
        super(props);
        this.onClick = () => {
            const { showDropdown } = this.state;
            this.setState({
                showDropdown: !showDropdown,
            });
        };
        this.handleSelectAll = () => {
            const { options, onChange } = this.props;
            const selected = [...options];
            this.setState({ selected });
            if (handleOnChange) {
                handleOnChange(options);
            }
        };
        this.handleDeselectAll = () => {
            const { handleOnChange } = this.props;
            this.setState({ selected: [] });
            if (handleOnChange) {
                handleOnChange([]);
            }
        };
        this.handleClickOutside = (event) => {
            var _a;
            if (this.state.showDropdown && ((_a = this.node) === null || _a === void 0 ? void 0 : _a.contains(event.target)) === false) {
                this.setState({
                    showDropdown: false,
                });
            }
        };
        const { selected, isMultiSelectable } = this.props;
        this.state = {
            showDropdown: false,
            selected: selected ? selected : [],
            isMultiSelectable: isMultiSelectable ? isMultiSelectable : false,
        };
    }
    componentDidMount() {
        document.addEventListener('mousedown', this.handleClickOutside.bind(this));
    }
    componentWillUnmount() {
        document.removeEventListener('mousedown', this.handleClickOutside.bind(this));
    }
    render() {
        const { buttonClass, placeholder, title, placeholderSelect, placeholderDeselect, name, onChange, getOptionLabel, getOptionKey, options, } = this.props;
        const { showDropdown, selected, isMultiSelectable } = this.state;
        return (React.createElement("div", { className: "dropdown", ref: (node) => (this.node = node) },
            React.createElement(DropdownMultiselectToggleBtn_1.DropdownMultiselectToggleBtn, { onClick: this.onClick, showDropdown: showDropdown, buttonClass: buttonClass, placeholder: placeholder, selected: selected, title: title }),
            React.createElement("div", { className: showDropdown ? 'dropdown-menu show' : 'dropdown-menu', style: { padding: 0, width: '100%' } },
                React.createElement(DropdownMultiselectSelection_1.DropdownMultiselectSelection, { handleSelect: this.handleSelectAll, handleDeselect: this.handleDeselectAll, isMultiSelectable: isMultiSelectable, placeholderSelect: placeholderSelect, placeholderDeselect: placeholderDeselect }),
                React.createElement(DropdownMultiselectOption_1.DropdownMultiselectOption, { setSelected: (value) => this.setState({ selected: value }), options: options, selected: selected, name: name, onChange: onChange, getOptionKey: getOptionKey, getOptionLabel: getOptionLabel }))));
    }
}
exports.DropdownMultiselect = DropdownMultiselectComponent;
