"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropdownMultiselectToggleBtn = void 0;
const React = require("react");
class DropdownMultiselectToggleBtnComponent extends React.Component {
    constructor() {
        super(...arguments);
        this.getTitle = () => {
            const { placeholder, title, selected } = this.props;
            if (selected) {
                if (placeholder && selected.length === 0) {
                    return placeholder;
                }
                else if (title && selected.length > 1) {
                    return title;
                }
                else {
                    if (typeof selected[0] === 'string') {
                        return selected.join(', ');
                    }
                    else {
                        // @ts-ignore
                        return selected.map((opt) => opt.label).join(', ');
                    }
                }
            }
            return '';
        };
    }
    render() {
        const { buttonClass, onClick } = this.props;
        const title = this.getTitle();
        return (React.createElement("button", { className: `btn btn-light dropdown-toggle ${buttonClass}`, type: "button", "data-toggle": "dropdown", "aria-haspopup": "true", "aria-expanded": "false", onClick: onClick, style: {
                width: '100%',
                overflow: 'hidden',
            } },
            React.createElement("span", { style: {
                    overflow: 'hidden',
                    textOverflow: 'ellipsis',
                    width: '100%',
                    float: 'left',
                    textAlign: 'left',
                    paddingRight: '6px',
                    marginRight: '-6px',
                } }, title)));
    }
}
exports.DropdownMultiselectToggleBtn = DropdownMultiselectToggleBtnComponent;
